Attribute VB_Name = "Utility"
Global GpibAddress As Integer
Global Device As Integer

Function GpibRd(ud As Integer, RdBuffer As String) As String
    Dim rsp As Integer

    RdBuffer = Space(256)
    Call ibrd(ud, RdBuffer)
    If iberr < 0 Then
        MsgBox "GPIB Error: does not open device", 16
        Exit Function
    End If
    RdBuffer = Mid(RdBuffer, 1, ibcnt)
    GpibRd = RdBuffer
End Function


Function GpibWrt(ud As Integer, SdBuffer As String) As String
    Dim last As String
    Dim BufLen As Integer
    Dim RdBuffer As String
    Dim rsp As Integer
    
    Call ibwrt(ud, SdBuffer)
    If iberr < 0 Then
        MsgBox "GPIB Error: does not open device", 16
        Exit Function
    End If
    
    BufLen = Len(SdBuffer)
    last = Mid(SdBuffer, BufLen)
    RdBuffer = ""
    If last = Chr(63) Then         'case Query chr(63) = '?'
        Call GpibRd(ud, RdBuffer)
    End If
    
    GpibWrt = RdBuffer
End Function

Function OpenDevice(GpibAddr As Integer)
    Dim GpibAddrStr As String
    Dim ud As Integer
    
    If GpibAddr < 1 Or GpibAddr > 30 Then
        MsgBox "GPIB Address Error: address 1 - 30"
        ud = -1
        OpenDevice = ud
        Exit Function
    End If
    
'GPIB Address
    If (GpibAddr = 1) Then GpibAddrStr = "dev1"
    If (GpibAddr = 2) Then GpibAddrStr = "dev2"
    If (GpibAddr = 3) Then GpibAddrStr = "dev3"
    If (GpibAddr = 4) Then GpibAddrStr = "dev4"
    If (GpibAddr = 5) Then GpibAddrStr = "dev5"
    If (GpibAddr = 6) Then GpibAddrStr = "dev6"
    If (GpibAddr = 7) Then GpibAddrStr = "dev7"
    If (GpibAddr = 8) Then GpibAddrStr = "dev8"
    If (GpibAddr = 9) Then GpibAddrStr = "dev9"
    If (GpibAddr = 10) Then GpibAddrStr = "dev10"
    If (GpibAddr = 11) Then GpibAddrStr = "dev11"
    If (GpibAddr = 12) Then GpibAddrStr = "dev12"
    If (GpibAddr = 13) Then GpibAddrStr = "dev13"
    If (GpibAddr = 14) Then GpibAddrStr = "dev14"
    If (GpibAddr = 15) Then GpibAddrStr = "dev15"
    If (GpibAddr = 16) Then GpibAddrStr = "dev16"
    If (GpibAddr = 17) Then GpibAddrStr = "dev17"
    If (GpibAddr = 18) Then GpibAddrStr = "dev18"
    If (GpibAddr = 19) Then GpibAddrStr = "dev19"
    If (GpibAddr = 20) Then GpibAddrStr = "dev20"
    If (GpibAddr = 21) Then GpibAddrStr = "dev21"
    If (GpibAddr = 22) Then GpibAddrStr = "dev22"
    If (GpibAddr = 23) Then GpibAddrStr = "dev23"
    If (GpibAddr = 24) Then GpibAddrStr = "dev24"
    If (GpibAddr = 25) Then GpibAddrStr = "dev25"
    If (GpibAddr = 26) Then GpibAddrStr = "dev26"
    If (GpibAddr = 27) Then GpibAddrStr = "dev27"
    If (GpibAddr = 28) Then GpibAddrStr = "dev28"
    If (GpibAddr = 29) Then GpibAddrStr = "dev29"
    If (GpibAddr = 30) Then GpibAddrStr = "dev30"
    
    Call ibfind(GpibAddrStr, ud)
    If (ud < 0) Then
        MsgBox "GPIB Error: ibfind does not find device.", 16
    
    ElseIf GpibCheckGpibError(ud) = True Then
        ud = -1
    End If
    
    OpenDevice = ud
        
End Function

Function GpibCheckGpibError(ud As Integer) As Integer
    Dim RdBuffer As String
    Dim ErrCode As Integer
    Dim rsp As Integer
    Dim err As Integer
    
    Call ibrsp(ud, rsp)

    err = False
    If (ibsta And EERR) Or (ibsta And TIMO) Then
        MsgBox "GPIB error! status:" + Hex(ibsta), 16
        err = True
    End If
    
    GpibCheckGpibError = err
    
End Function

Function GpibCheckError(ud As Integer) As Integer
    Dim RdBuffer As String
    Dim ErrCode As Integer
    
    RdBuffer = GpibWrt(ud, "*ESR?")
    ErrCode = Val(RdBuffer) And &H3C   'CME, EXE, DDE, QYE

    If ErrCode > 0 Then
        RdBuffer = GpibWrt(ud, "SYSTEM:ERROR?")
        MsgBox "GPIB Status: " + RdBuffer
    End If
    
    GpibCheckError = ErrCode
    
End Function

Sub GpibControlEOI(ud As Integer, Status As Integer)

    Call ibeot(ud, Status)
    
End Sub


Sub GpibWriteByte(ByVal ud As Integer, byt() As Byte, ByVal length As Integer)
    Dim tmpUD As Integer
    Dim cnt As Long
    Dim rc As String
    
' Check to see if GPIB Global variables are registered
    If (GPIBglobalsRegistered = 0) Then
      Call RegisterGPIBGlobals
    End If

' Convert Integer parameters into Longs.
    tmpUD = CLng(ud)
    cnt = CLng(length)
    
' Call the 32-bit DLL.
    rc = ibwrt32(ByVal tmpUD, byt(0), ByVal cnt)
        
    Call copy_ibvars
End Sub

Function MakeHexDump(Buffer As String) As String
    Dim HexStr As String
    Dim DatStr As String
    Dim DmpStr As String
    Dim Ch As String
    Dim OneHexStr As String
    Dim OneDatStr As String
    Dim i As Integer
    Dim j As Integer

    DmpStr = ""
    i = 0
    Do While i < Len(Buffer)
        HexStr = ""
        DatStr = ""
        j = 0
        Do While j < 16 ' And i < Len(Buffer)
            i = i + 1
            j = j + 1
            
            Ch = Mid(Buffer, i, 1)
            
            OneHexStr = Hex(Asc(Ch) And &HFF)
            
            If Len(OneHexStr) = 1 Then
                OneHexStr = "0" + OneHexStr
            End If
            HexStr = HexStr + " " + OneHexStr
            
            If Asc(Ch) < 32 Then
                OneDatStr = "."
            Else
                OneDatStr = Ch
            End If
            DatStr = DatStr + " " + OneDatStr
            
            If i >= Len(Buffer) Then
                Do While j < 16
                    j = j + 1
                    HexStr = HexStr + "   "
                    DatStr = DatStr + "  "
                Loop
                Exit Do
            End If
        Loop
        DmpStr = DmpStr + HexStr + "    " + DatStr + Chr(13) + Chr(10)
    Loop
    
    'MsgBox DmpStr
    
    MakeHexDump = DmpStr
End Function

Function MakeExpStr(num As Single) As String
    Dim dbl As Double
    Dim n As Integer
    Dim ExpStr As String
    
    dbl = num
    n = 0
    If dbl >= 10# Then
        Do While dbl >= 10#
            dbl = dbl / 10#
            n = n + 1
        Loop
        ExpStr = Format(dbl, "0.0000000000") + "E+" + Format(n, "000")
    Else
        Do While dbl < 1#
            dbl = dbl * 10#
            n = n - 1
        Loop
        ExpStr = Format(dbl, "0.0000000000") + "E" + Format(n, "000")
    End If
    MakeExpStr = ExpStr
End Function

